"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var service_1 = require("../service");
var mongodb = require("mongodb");
var MongodbService = (function (_super) {
    __extends(MongodbService, _super);
    function MongodbService(settings) {
        var _this = _super.call(this) || this;
        _this.name = "MongodbService";
        var info = settings.database || {};
        _this.port = info.port || 27017;
        _this.dbName = info.name || "test";
        _this.host = info.host || "localhost";
        return _this;
    }
    MongodbService.prototype.initialize = function (done) {
        var _this = this;
        console.log("Connecting to database", "mongodb://" + this.host + ":" + this.port + "/" + this.dbName);
        mongodb.MongoClient.connect("mongodb://" + this.host + ":" + this.port + "/" + this.dbName, function (err, db) {
            _this.db = db;
            done(err);
        });
    };
    MongodbService.prototype.asBuiltIn = function () {
        console.log("MongodbService using mongo://" + this.host + ":" + this.port + "/" + this.dbName);
    };
    return MongodbService;
}(service_1.Service));
exports.MongodbService = MongodbService;
//# sourceMappingURL=mongodbService.js.map