export function APIDecorator<TThis = any, TOption = null>(fn: (option: TOption) => APIDecorator<TThis, TOption>) {
    return function (option?: TOption) {
        let handler = fn(option)
        return function (obj: TThis, name: string, descriptor: TypedPropertyDescriptor<Function>) {
            let orig = descriptor.value
            descriptor.value = function () {
                handler.call(this, orig.bind(this), option)
            }
        }
    }
}
export interface APIDecorator<TThis = any, TOption = null> {
    (this: TThis, orig: Function, option?: TOption): void
}

export interface Decorator {
    (obj: any, name: string, descriptor: TypedPropertyDescriptor<Function>): void
}

